IDL_PROG			= $(L4DIR)/idl4re/idl

# Functions to generate filenames.

export_includes			= $(patsubst %,$(IDL_EXPORT_DIR)/%,$(1))

interfaces_to_idl 		= $(patsubst %,$(IDL_DIR)/%.idl,$(1))

interfaces_to_client_c		= \
				$(patsubst %,%_client.c,$(1)) \

interfaces_to_client_c_h	= \
				$(patsubst %,%_client.c,$(1)) \
				$(patsubst %,%_client.h,$(1)) \

interfaces_to_client_cc		= \
				$(patsubst %,%_client.cc,$(1)) \

interfaces_to_client_cc_h	= \
				$(patsubst %,%_client.cc,$(1)) \
				$(patsubst %,%_client.h,$(1)) \

interfaces_to_server_c		= \
				$(patsubst %,%_server.c,$(1)) \

interfaces_to_server_c_h	= \
				$(patsubst %,%_server.c,$(1)) \
				$(patsubst %,%_server.h,$(1)) \

interfaces_to_server_cc		= \
				$(patsubst %,%_server.cc,$(1)) \

interfaces_to_server_cc_h	= \
				$(patsubst %,%_server.cc,$(1)) \
				$(patsubst %,%_server.h,$(1)) \

interfaces_to_interface_h 	= \
				$(patsubst %,%_interface.h,$(1)) \

interfaces_to_interfaces_h 	= \
				$(patsubst %,%_interface.h,$(1)) \
				$(patsubst %,%_interfaces.h,$(1)) \

# For each interface <name>, obtain a variable of the form <name>_INTERFACES,
# accumulating words from each variable. The resulting list is sorted and
# without duplicate words.

common_interfaces = $(sort $(foreach INTERFACE,$(1),$(value $(INTERFACE)_INTERFACES)))

# Generation of exported interface header file locations.

exported_interfaces_h = $(foreach INTERFACE,$(call interfaces_to_interface_h,$(1)),$(call export_includes,$(INTERFACE)))
